Name:           mod_tile
Version:        0.5
Release:        0.8%{?dist}
Summary:        Renders and serves OpenStreetMap map tiles using apache
URL:            https://github.com/openstreetmap/mod_tile
Source0:        https://github.com/openstreetmap/mod_tile/archive/master.zip
Source1:        mod_tile.conf
Source2:        mod_tile.module.conf
Source3:        renderd.service
Source4:        renderd.tmpfiles
Source5:        netdata-mod_tile.chart.py
Source6:        netdata-mod_tile.conf
Source7:        netdata-renderd.chart.py
Source8:        netdata-renderd.conf
Patch0:         mod_tile-fix-renderd-conf.patch
License:        GPLv2+
Requires:       httpd
BuildRoot:      %{_tmppath}/%{name}-%{version}-root
BuildRequires:  httpd-devel
BuildRequires:  mapnik-devel
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  libtool
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  boost-devel
BuildRequires:  libicu-devel
BuildRequires:  cairo-devel
BuildRequires:  proj-devel
BuildRequires:  libxml2-devel
BuildRequires:  libtiff-devel
BuildRequires:  libjpeg-devel
BuildRequires:  iniparser-devel
BuildRequires:  systemd
Requires:       renderd = %{version}

%description
A program to efficiently render and serve map tiles for
OpenStreetMap map using Apache and Mapnik.

%package -n renderd
Summary:        Renders OpenStreetMap map tiles daemon
Requires(post): systemd-sysv

%description -n renderd
Renders OpenStreetMap map tiles for mod_tile

%package munin
Summary:        Munin plugins for mod_tile
Requires:       munin-node

%description munin
Munin plugins for mod_tile

%package netdata
Summary:        netdata plugins for mod_tile
Requires:       netdata

%description netdata
netdata plugins for mod_tile

%prep
%setup -qn %{name}-master
%patch0 -p1
./autogen.sh

%build
%{configure}
%{__make}
pushd extra
%{__make}
popd

%install
%{__make} install DESTDIR="%{buildroot}"
%{__make} install-mod_tile DESTDIR="%{buildroot}"
%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf.modules.d
%{__install} -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf
%{__install} -Dp -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/99-%{name}.conf
%{__install} -Dp -m0755 extra/meta2tile %{buildroot}%{_bindir}/meta2tile

# Daemons must be located on %%sbindir
%{__mkdir_p} %{buildroot}%{_sbindir}
%{__mv} %{buildroot}%{_bindir}/renderd %{buildroot}%{_sbindir}/renderd
%{__mkdir_p} %{buildroot}%{_localstatedir}/lib/mod_tile
%{__install} -Dp -m0644 %{SOURCE3} %{buildroot}%{_unitdir}/renderd.service
%{__install} -Dp -m0644 %{SOURCE4} %{buildroot}%{_tmpfilesdir}/renderd.conf

# munin plugins
%{__mkdir_p} %{buildroot}%{_datadir}/munin/plugins
%{__install} -Dp -m0755 munin/* %{buildroot}%{_datadir}/munin/plugins

# netdata plugins with conf
%{__mkdir_p} %{buildroot}%{_libexecdir}/netdata/python.d/
%{__mkdir_p} %{buildroot}%{_sysconfdir}/netdata/python.d/
%{__install} -Dp -m0644 %{SOURCE5} %{buildroot}%{_libexecdir}/netdata/python.d/mod_tile.chart.py
%{__install} -Dp -m0644 %{SOURCE7} %{buildroot}%{_libexecdir}/netdata/python.d/renderd.chart.py
%{__install} -Dp -m0644 %{SOURCE6} %{buildroot}%{_sysconfdir}/netdata/python.d/mod_tile.conf
%{__install} -Dp -m0644 %{SOURCE8} %{buildroot}%{_sysconfdir}/netdata/python.d/renderd.conf

%pre -n renderd
getent group osm > /dev/null || groupadd -r osm
getent passwd osm > /dev/null || useradd -r -g osm -c "OpenStreetMap User" -s /sbin/nologin -d /var/lib/mod_tile osm

%post -n renderd
%if 0%{?systemd_post:1}
%systemd_post renderd.service
%else
if [ $1 = 1 ]; then
    /usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
    /usr/bin/systemd-tmpfiles --create >/dev/null 2>&1 || :
fi
%endif

%preun -n renderd
%if 0%{?systemd_preun:1}
%systemd_preun renderd.service
%else
if [ "$1" = 0 ] ; then
    # Package removal, not upgrade
    /usr/bin/systemctl --no-reload disable renderd.service >/dev/null 2>&1 || :
    /usr/bin/systemctl stop renderd.service >/dev/null 2>&1 || :
fi
exit 0
%endif

%postun -n renderd
%if 0%{?systemd_postun_with_restart:1}
%systemd_postun_with_restart renderd.service
%else
/usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ]; then
# Package upgrade, not uninstall
    /usr/bin/systemctl try-restart renderd.service >/dev/null 2>&1 || :
fi
%endif

%files
%doc readme.txt docs slippymap.html
%{_libdir}/httpd/modules/mod_tile.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config %{_sysconfdir}/httpd/conf.modules.d/99-%{name}.conf

%files -n renderd
%doc renderd.py
%config(noreplace) %{_sysconfdir}/renderd.conf
%{_sbindir}/renderd
%{_bindir}/render_expired
%{_bindir}/render_list
%{_bindir}/render_old
%{_bindir}/render_speedtest
%{_bindir}/meta2tile
%{_mandir}/man*/render*
%attr(0755,osm,osm) %dir %{_localstatedir}/lib/mod_tile
%{_unitdir}/renderd.service
%{_tmpfilesdir}/renderd.conf

%files munin
%{_datadir}/munin/plugins/*

%files netdata
%{_libexecdir}/netdata/python.d/*.chart.py*
%config(noreplace) %{_sysconfdir}/netdata/python.d/*.conf

%changelog
* Tue Jul 04 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.8
- netdata subpackage

* Thu Jun 29 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.7
- munin subpackage
- Add extra/meta2tile

* Sun Jun 18 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.6
- Stop providing /var/lib/mod-tile directory
- Fix osm home permissions

* Fri Jun 16 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.5
- Remove group
- Rebuild against mapnik 3

* Thu Jun 15 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.4
- Run systemd-tmpfiles --create on post
- Fix osm home to /var/lib/mod_tile

* Mon Jun 12 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.3
- Fix renderd conf and 

* Mon Jun 12 2017 Didier Fabert <dfabert@b2pweb.com> 0.5-0.2
- First package
